
; - Draw RTJFBV FLange profile Function.
(defun RTJFBV_DDH ( / RTJFBV1  RTJFBV2  RTJFBV3  RTJFBV4  RTJFBV5  RTJFBV6  RTJFBV7  RTJFBV8  RTJFBV9 RTJFBV10;
					  RTJFBV11 RTJFBV12 RTJFBV13 RTJFBV14 RTJFBV15 RTJFBV16 BV_BALL BV_BODY RTJFBV19 RTJFBV33;
					  oldlayer BMK# BCTR# BALOD# SPIGOT#)
	(setq oldlayer (getvar "CLAYER")) ; get current layer  
	(command "-layer" "S" "0" "")
	(entmakex
		(list
            (cons 0 "LWPOLYLINE")			;defines draw a LWPOLYLINE remember ""'s
            (cons 100 "AcDbEntity")			;defines draw an entity
;;----------(cons 8 LNAM)					;defines the layer specifics, if ommited uses default (is that current?)
            (cons 100 "AcDbPolyline")		;defines draw a LWPOLYLINE
            (cons 90 (length VRT#))
            (cons 70 1)						; 1 for closed 0 overwise;
			(cons 10 PT01)					;(cons 10 PNT number)				  
			(cons 42 0.0)					;(cons 42 BF  number)					  
			(cons 10 GV01)
			(cons 42 0.0)
			(cons 10 GV02)
			(cons 42 0.0)
			(cons 10 GV03)
			(cons 42 0.0)
			(cons 10 GV04)
			(cons 42 0.0)
			(cons 10 PT02)
			(cons 42 0.0)			
			(cons 10 PT03)
			(cons 42 0.0)
			(cons 10 PT04)
			(cons 42 0.0)			
			(cons 10 FR01)
			(cons 42 0.4142)
			(cons 10 FR02)
			(cons 42 0.0)
			(cons 10 PT05)
			(cons 42 0.0)			
			(cons 10 PT08)
			(cons 42 0.0)
			(cons 10 PT09)
			(cons 42 0.0)
			(cons 10 PT10)
			(cons 42 0.0)			
		);end list
	);end entmake
;--------------------------------------------------------------------
; - draw 3D Blind Solid/Create Block
	(setq BMK# (* 0.5 (- FTF# BL#)))
	(setq BCTR# (* 0.5 FTF#))
	(setq BALOD# (* 0.75 FOD#))
	(setq SPIGOT# (* 0.5 FOD#))
	(progn
		(command "ucs" "w" "")
		(setq RTJFBV1 (entlast))
		(command "revolve" RTJFBV1 "" "0,0,0" "0,100,0" "360")
		(setq RTJFBV2 (entlast))		
		(command "_erase" RTJFBV1 "")
		(command "ucs" "ZA" P1 P2)
		(command "UCS" "3" "" "0,0,-1" "0,1,0")
		(command "-layer" "m" "HOLES" "S" "" "")
		(command "_cylinder" (strcat (rtos (* 0.5 HPCD#)) ",0,0") (* 0.5 HOD#) (rtos LHOD#))
		(command "-layer" "S" "0" "")
		(command "-array" "L" "" "P" "0,0" (rtos HOL#) "360" "" "")
		(command "_subtract" RTJFBV2 "" (ssget "_x" '((0 . "3DSOLID")(8 . "HOLES"))) "" "")
		(setq RTJFBV3 (entlast))
; END OF FLANGE ONE
		(command "UCS" "W" "")	
		(command "_COPY" RTJFBV3 "" (strcat "@0," (rtos FTF#) ",0") "")
		(setq RTJFBV3A (entlast))
		(command "_Rotate" RTJFBV3A "" (strcat "0," (rtos FTF#) ",0") "180" "")
		(setq RTJFBV4 (entlast))
; END OF FLANGE TWO	
; CREATE BODY O/D AND I/D (2 OFF)
; BODY O/D	
		(command "_Circle" (strcat "0," (rtos BMK#) ",0") "D" FOD# "")
		(setq RTJFBV5 (entlast)) ;body O/D
		(command "_Extrude" RTJFBV5 "" BL# "")
		(setq RTJFBV6 (entlast))	 ;body O/D	
		(command "_erase" RTJFBV5  "")
; BODY I/D 1		
		(command "_Circle" (strcat "0," (rtos BMK#) ",0") "D" BORE# "")
		(setq RTJFBV7 (entlast)) ;body I/D		
		(command "_Extrude" RTJFBV7 "" BL# "")
		(setq RTJFBV8 (entlast)) ;body I/D	1	
		(command "_erase" RTJFBV7  "")
; ROTATE BODY O/D & I/Ds		
		(command "_ROTATE3D" RTJFBV6 RTJFBV8 "" "X" (strcat "0," (rtos BMK#) ",0") "270" "")
; END OF BODY		
; SUBTRACT BORE FROM BODY/BALL
		(command "_subtract" RTJFBV6 "" RTJFBV8 "")
		(setq RTJFBV11 (entlast))
;  CREATE BALL & SUBTRACT BALL FROM BODY		
		(command "_sphere" (strcat "0," (rtos BCTR#) ",0") "D" BALOD# "")
		(setq RTJFBV12 (entlast))
		(command "_subtract" RTJFBV11 "" RTJFBV12 "")
		(setq RTJFBV13 (entlast))
; BODY I/D 2		
		(command "_Circle" (strcat "0," (rtos BMK#) ",0") "D" BORE# "")
		(setq RTJFBV9 (entlast)) ;body I/D	2
		(command "_Extrude" RTJFBV9 "" BL# "")
		(setq RTJFBV10 (entlast)) ;body I/D	2
		(command "_erase" RTJFBV9  "")
; ROTATE BODY O/D & I/Ds		
		(command "_ROTATE3D" RTJFBV10 "" "X" (strcat "0," (rtos BMK#) ",0") "270" "")
; CREATE BALL & SUBTRACT BORE	
		(command "_sphere" (strcat "0," (rtos BCTR#) ",0") "D" BALOD# "")
		(setq RTJFBV14 (entlast))
		(command "_CYLINDER" (strcat "0," (rtos BCTR#) ",0") "D" HOD# (+ 10.00 SPIGOT#))
		(setq RTJFBV15 (entlast))		
		(command "_UNION" RTJFBV14 RTJFBV15 "")
		(setq RTJFBV16 (entlast))
		(command "_subtract" RTJFBV16 "" RTJFBV10 "")
		(setq BV_BALL (entlast))
		(command "_change" BV_BALL "" "P" "C" "1" "")	;Red		
		(command "_ROTATE" BV_BALL "" (strcat "0," (rtos BCTR#) ",0") "15")
		(setq BVBALL (entlast))
		(command "_.-Block" (strcat FLG1 "-BALL") "Y" "0,0,0" BVBALL "")		
; END BALL & BORE
		(setq SS (SSADD))		
		(command "union" RTJFBV3 RTJFBV4 RTJFBV13 "")
		(setq BVBODY (entlast))
		(command "_.-Block" (strcat FLG1 "-BODY") "Y" "0,0,0" BVBODY "")		
		(command "UCS" "W" "")
		(command "-Insert" (strcat FLG1 "-BODY") "0,0,0" "" "" "180")
		(setq BODY (entlast))
		(ssadd BODY SS)		
		(command "-Insert" (strcat FLG1 "-BALL") "0,0,0" "" "" "180")		
		(setq BALL (entlast))		
		(ssadd BALL SS)	
		(command "_.-Block" FLG1 "0,0,0" SS "")
	) ;end progn
	(setvar "CLAYER" oldlayer)
	(dellay "HOLES")	
	(princ)
	(INS_FLG